I&#39;m the source of the 32-bit recommendation, and the HP Mac distribution builder<div><br></div><div>To summarize what I read in this thread:</div><div><ol><li>32-bit GHC/HP didn&#39;t work with 64-bit Cario libs</li>
<li>Some libs available via brew were 64-bit, and 32-bit ones would have to be compiled</li><li>There is still some bug with 64-bit ghci and some graphics libs</li><li>There is a ghc bug with 64-bit on mac (bug #7040), which isn&#39;t fixed until 7.6</li>


</ol>There seemed to be the implication that a 64-bit ghc would work with 32-bit libs, but I don&#39;t think that&#39;s true. Mac doesn&#39;t (generally) support mixed modes in the same executable. All system libs are shipped dual-architecture. I don&#39;t think there are any pre-installed libs that are shipped 64-bit only. The problem seen with Cairo would cut both ways: If one had installed the 32-bit version of Cairo, one would see the same problem with the 64-bit HP: &quot;<span style="background-color:rgb(255,255,255);color:rgb(34,34,34);font-family:arial,sans-serif;font-size:13px">wrong architecture&quot;.</span></div>


<div><br></div><div>Since code compiled with the 32-bit system is both faster, and uses less memory, and it has been the case that all libs are either shipped dual-arch, or easily available as 32-bit, and there were known problems with the 64-bit version for some use cases, it seemed to me to be best to suggest the 32-bit version by default.</div>


<div><br></div><div>The major source of the problems in the OP, seem to be that MacPorts and/or brew don&#39;t appear to follow the Mac OS X lib standard of installing libs dual arch. A brief look at the MacPorts page indicated that there were various rules (OS version and processor version) that determined which arch. it built by default. Perhaps we should tell people to install the HP architecture that matches the architecture that they use for MacPorts or brew. However, I bet most people don&#39;t know, so we&#39;d need a pointer to where they could find out the defaults for those systems, or how to establish what their system is using.</div>

<div><br></div><div>Finally, I note that HP 2012.4.0.0 (out in a month) will ship with GHC 7.4.2, and so will still have the above bugs.</div><div><br></div><div>- Mark</div><div><br></div>